#include "testlib.h"
#include <iostream>
#include <string>
#include <vector>

using namespace std;

bool viv = false;

int dif(vector<string> v) {
	set<string> s;
	for (auto i : v)
		s.insert(i);
	return s.size();
}

int readAns(InStream& in, string &s) {
	int n = in.readInt(0, 100);
	vector<string> vals(n);
	for (auto &val : vals)
		val = in.readWord("[1-9][0-9]|[0-9]");

	//ensure(vals.size() == dif(vals));

	set<string> tokens;
	for (auto i : vals)
		tokens.insert(i);

	vector<bool> dp(s.size() + 1, false);
	dp[0] = true;
	for (int i = 0; i < s.size(); i++) {
		if (dp[i] && tokens.find(s.substr(i, 1)) != tokens.end()) 
			dp[i + 1] = true;
		if (i && dp[i - 1] && tokens.find(s.substr(i - 1, 2)) != tokens.end()) 
			dp[i + 1] = true;
	}
	if (viv) {
		for (auto i : dp)
			cout << i << ' ';
		cout << endl;
	}
	if (!dp.back())
		return -1;
	return n;
}

double readTest(int tn) {
	string s = inf.readWord();
	if (viv)
		cout << "s = " << s << endl;
	int pa = readAns(ouf, s);
	int ja = readAns(ans, s);

	ensuref(ja != -1, "Jury's answer is incorrect [test: %d]", tn);
	if (pa == -1)
		return 0;

	if (pa < ja)
		quitf(_fail, "Participant's answer is better [test: %d]\n", tn);

	double res = 1;
	for (int i = ja; i < pa; i++)
		res /= 2;
	return res;
}

int main(int argc, char * argv[]) {
	registerTestlibCmd(argc, argv);
	double ans = 0;
	int t = inf.readInt();
	for (int i = 0; i < t; i++) {
		ans += readTest(i);
	}
	ans /= t;
	ans *= 70;
    printf("%lf", ans);
	quitf(_ok, "Ok");
}
